﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Boat : MonoBehaviour {

    private Transform tr;

    private Vector3 startingPosition;
    private Vector3 startingRotation;
    private Vector3 startingScale;

    private bool alive;

    public float deathRotationSpeed;
    public float drowningSpeed;
    //public float numberOf360;

    // setta le variabili iniziali
    void Start ()
    {
        tr = GetComponent<Transform>() as Transform;
        startingPosition = tr.localPosition;
        startingRotation = tr.eulerAngles;
        startingScale = tr.localScale;

        alive = true;
    }
	
    // gestisce il movimento della barca sull'onda tramite una funzione di rumore
	void Update ()
    {
        if ((alive)&&(!tr.parent.gameObject.GetComponent<Player>().isEndLevel()))
            tr.localPosition = new Vector3(tr.localPosition.x, startingPosition.y + ((Mathf.PerlinNoise(tr.position.x * Time.time, 0f) * 2 - 1) * 0.1f), 0);
        //tr.localEulerAngles = new Vector3(0, 0, ((Mathf.PerlinNoise(tr.position.x * Time.time, 0f) * 2 - 1) * 12f));
	}

    // setta la morte e fa partire la rispettiva animazione
    public void Death()
    {
        if (alive)
        {
            GameManager.Instance.PlayerAlive = false;
            alive = false;

            StartCoroutine(DeathAnimation());
        }
    }

    // animazione morte della barca
    private IEnumerator DeathAnimation()
    {
        float angle = 0f;
        //float scale = 1f;

        tr.SetParent(null);
        SpawnManager.Instance.RespawnPlayer(this, false);

        do
        {
            angle += deathRotationSpeed;
            //scale -= drowningSpeed;
            tr.eulerAngles = new Vector3(0f, 0f, angle);
            tr.position = tr.position + Vector3.down * drowningSpeed;
            //tr.localScale = new Vector3(scale, scale, scale);
            yield return new WaitForEndOfFrame();
        } while (angle < 540f); // (scale > 0f);


        yield return new WaitForSeconds(0.5f);
        gameObject.SetActive(false);
    }

    // resetta prima di una nuova partita
    public void Reset()
    {
        tr.SetParent(GameObject.FindGameObjectWithTag("Wave").GetComponent<Transform>());

        tr.localPosition = startingPosition;
        tr.eulerAngles = startingRotation;
        tr.localScale = startingScale;

        gameObject.SetActive(true);
        GameManager.Instance.PlayerAlive = true;
        alive = true;
    }
}
