﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Enemy : MonoBehaviour {

    private Rigidbody2D rb;
    private Animator anim;

    private bool dead;

    public float speed;
    public float amplitude;

    public int points;

    private float a, b;
    
    // setta variabili e segnala oggetto in scena
    void Start () {
        GameManager.Instance.AddGameObjectToTheScreen(gameObject);
        rb = GetComponent<Rigidbody2D>();
        anim = GetComponent<Animator>();

        b = Time.time;
        a = 5;

        dead = false;

        speed *= GameManager.Instance.Multiplier;

        if (gameObject.name.Equals("Fish(Clone)"))
            Destroy(gameObject);

        if (speed == 0)
            Debug.Log("Multiplier: " + GameManager.Instance.Multiplier);
    }
	
    // muove nemico a sinistra
	void Update () {
        rb.position = rb.position + Vector2.left * speed * Time.deltaTime +
            Vector2.down * (dead ? speed * 2f * Time.deltaTime : Mathf.Sin(Time.time * a - b) * amplitude);

        if (rb.position.x <= GameManager.Instance.worldBound.x) // oltre il visibile
            Destroy(gameObject);
	}

    // collisioni:
        // se colpisce un'onda, non è già morto ed il giocatore è vivo -> muore
        // se colpisce un giocatore e non è morto 
    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.CompareTag("Wave") && !dead && GameManager.Instance.PlayerAlive) // se il giocatore è morto non muoiono più contro l'onda
            StartCoroutine(Die());
        else if (other.CompareTag("Player") && !dead)
            other.GetComponent<Boat>().Death();
    }

    // toglie elemento dalla lista degli elementi attivi
    void OnDestroy()
    {
        GameManager.Instance.RemoveGameObjectFromTheScreen(gameObject);
    }

    // gestisce animazione morte
    private IEnumerator Die()
    {
        PointsManager.Instance.AddPoints(points);

        dead = true;
        anim.SetTrigger("Die");
                        
        if(Random.value > 0.5f)
            POLIMIGameCollective.SfxManager.Instance.Play("sfx_enemyDeath_01");
        else
            POLIMIGameCollective.SfxManager.Instance.Play("sfx_enemyDeath_02");

        yield return new WaitForSeconds(2f);
        Destroy(gameObject);
    }
}
