﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Laser : Weapon {
    private SpriteRenderer sr;

    public float finalPositionX = 1.15f;
    public float speed;
    public float onOffSpeed;

    public float duration;

	new void Start () {
        base.Start();
        tr = GetComponent<Transform>();
        sr = GetComponent<SpriteRenderer>();
        
        POLIMIGameCollective.SfxManager.Instance.Play("sfx_bossAttackLaser");

        ;

        StartCoroutine(ManageObject());
	}

	private IEnumerator ManageObject()
    {
        do
        {
            tr.position = tr.position + Vector3.left * speed;
            yield return new WaitForEndOfFrame();
        } while (tr.position.x - finalPositionX > 0f);

        yield return new WaitForSeconds(duration);

        StartCoroutine(OnOff(5));
    }

    private IEnumerator OnOff(int i)
    {
        float alpha = 1f;
        Color c = sr.color;

        while (alpha < 1)
        {
            alpha += onOffSpeed;
            sr.color = new Color(c.r, c.g, c.b, alpha);
            yield return new WaitForEndOfFrame();
        }

        while (alpha > 0)
        {
            alpha -= onOffSpeed;
            sr.color = new Color(c.r, c.g, c.b, alpha);
            yield return new WaitForEndOfFrame();
        }

        i--;
        if(i > 0)
            StartCoroutine(OnOff(i));
        else
            Destroy(gameObject);
    }
}
