﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MovingWave : MonoBehaviour {

    public Transform tr_waveone;
    public Transform tr_wavetwo;
    public Transform tr_wavethree;

    public float speedGameplay;
    public float speedNoGameplay;

    private float speed;

    private float distance;
    private float initialPositionX;

    void Start()
    {
        distance = Mathf.Abs(tr_waveone.position.x - tr_wavetwo.position.x);
        initialPositionX = tr_waveone.position.x;

        speed = speedNoGameplay;
        GameManager.Instance.theStartWorld.AddListener(TheStart);
    }

    void Update()
    {
        tr_waveone.position = tr_waveone.position + Vector3.left * speed * Time.deltaTime * GameManager.Instance.Divider * 1 / 3;
        tr_wavetwo.position = tr_wavetwo.position + Vector3.left * speed * Time.deltaTime * GameManager.Instance.Divider * 1 / 3;
        tr_wavethree.position = tr_wavethree.position + Vector3.left * speed * Time.deltaTime * GameManager.Instance.Divider * 1 / 3;

        if (tr_waveone.position.x <= initialPositionX - distance)
            tr_waveone.position = tr_wavethree.position + Vector3.right * distance;

        if (tr_wavetwo.position.x <= initialPositionX - distance)
            tr_wavetwo.position = tr_waveone.position + Vector3.right * distance;

        if (tr_wavethree.position.x <= initialPositionX - distance)
            tr_wavethree.position = tr_wavetwo.position + Vector3.right * distance;
    }

    public void TheStart()
    {
        speed = speedGameplay;
    }
}
