﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class PointsManager : MonoBehaviour {

    private static PointsManager instance;
    public static PointsManager Instance
    {
        get { return instance; }
    }

    private int points;
    public int Points
    {
        get { return points; }
    }

    public int increaseDifficultyThreshold;
    private int thresholdCounter;

    public int pointsToTheBoss;

    public Text text;
    public Image slider;

    public CanvasGroup hud;

    void Awake()
    {
        if (instance == null)
            instance = this;
        else
            Destroy(gameObject);
    } 

    void Start () {
        points = 0;
        thresholdCounter = 0;
        UpdateText();

        hud.alpha = 0f;

        GameManager.Instance.theStart.AddListener(TheStart);
    }

    public void TheStart()
    {
        hud.alpha = 1f;
    }
	
	public void AddPoints(int points)
    {
        this.points += points;
        thresholdCounter += points;

        if(thresholdCounter >= increaseDifficultyThreshold)
        {
            GameManager.Instance.IncreaseDifficulty();
            thresholdCounter = 0;
        }

        UpdateText();
    }

    public void UpdateText()
    {
        text.text = "Points: " + points;
        
        slider.fillAmount = (float)points / pointsToTheBoss;

        if (points >= pointsToTheBoss)
            GameManager.Instance.CallTheBoss();
    }

    // resetta per la nuova partita
    public void ResetPoints()
    {
        points = 0;
        UpdateText();
    }
}
